      SUBROUTINE AVERAG(EIGE,PROPER,NDIM,S,SCR,SCR1,QUANTU,
     &                  MINVVA,MAXVVA,MINJVA,MAXJVA,PROPTY)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      COMMON/IO/LUIN,LUOUT

      DIMENSION EIGE(NDIM-2,NDIM-2),S(NDIM-2,NDIM-2),PROPER(NDIM-2)
      DIMENSION SCR(NDIM-2,NDIM-2),SCR1(NDIM-2,NDIM-2)
      DIMENSION PROPTY(MINVVA:MAXVVA,MINJVA:MAXJVA) 
      

* The desired integrals are < psi | property | psi > 
* Multiply the eigenfunctions by the property vector 
      DO 100 I=1,NDIM-2
        DO 100 J=1,NDIM-2
         SCR(J,I)=EIGE(J,I)*PROPER(J) 
100   CONTINUE 

*  Multiply eigenfunction times property vector by the overlap matrix
      CALL MATML4(SCR1,S,SCR,
     &            NDIM-2,NDIM-2,NDIM-2,NDIM-2,NDIM-2,NDIM-2,0)

*  The scalar product gives us the final result
      DO 200 I=1,NDIM-2
        AVPROP=DDOT(NDIM-2,SCR1(1,I),1,EIGE(1,I),1)
        SCR(I,1)=AVPROP
200   CONTINUE 
     
*  Save the property in Propty
      J=NINT(QUANTU)
      DO 300 IVIB=MINVVA,MAXVVA
        PROPTY(IVIB,J)=SCR(IVIB,1)
300   CONTINUE 

*     WRITE(LUOUT,*)
*     WRITE(LUOUT,'(A)') ' The vibrationally averaged property'
*     WRITE(LUOUT,'(A,1X,I3)') ' Calculated for J= ',NINT(QUANTU)
*     WRITE(LUOUT,*) 
*     WRITE(LUOUT,1000) (SCR(IVIB,1),IVIB=MINVVA,MAXVVA)
*     WRITE(LUOUT,*)
*1000 FORMAT(5(D13.6,2X))
*     IF(NINT(QUANTU).EQ.MINJVA) THEN
*       WRITE(LUOUT,'(A)') ' The vibrationally averaged property'
*       WRITE(LUOUT,*)
*     END IF
      MAXWWA=MIN(5,MAXVVA)
      WRITE(LUOUT,'(A,3X,I4,3X,5(D13.6,2X))') 'PRO',NINT(QUANTU),
     &  (SCR(IVIB,1),IVIB=MINVVA,MAXWWA)
      IF(MAXVVA.GT.5) THEN
        WRITE(LUOUT,'(A,10X,5(D13.6,2X))') 'PRO',
     &  (SCR(IVIB,1),IVIB=MAXWWA,MAXVVA)
      END IF
              
      RETURN
      END
