      SUBROUTINE COORD2(RS,H,NPOINT,NCELL,RINFIN,COORD)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RS(NCELL),H(NCELL),COORD((NPOINT-1)*NCELL+1)
 
*   Exponential grid
*   Set coordinates for beginning of cell and step lengths
      RS(1)=0.D0
      T0=0.D0
      TMAX=LOG(RINFIN+1.D0)
      DELT=(TMAX-T0)/NCELL
 
      DO 100 I=2,NCELL
        T=(I-1)*DELT
        RS(I)=EXP(T)-1.D0
        H(I-1)=(RS(I)-RS(I-1))/(NPOINT-1)
 100  CONTINUE
      H(NCELL)=(RINFIN-RS(NCELL))/(NPOINT-1)
 
      K=0
      DO 200 I=1,NCELL
        CST=RS(I)-H(I)
        DO 200 J=1,NPOINT-1
          K=K+1
          COORD(K)=CST+H(I)*J
200   CONTINUE
      K=K+1
      COORD(K)=COORD(K-1)+H(NCELL)

      RETURN
      END
