      SUBROUTINE COORD3(RS,H,NPOINT,NCELL,RAV,RINFIN,COORD)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RS(NCELL),H(NCELL),COORD((NPOINT-1)*NCELL+1)

*   Biexponential grid  
*   Set coordinates for beginning of cell and step lengths
*   The number of elements for the inner part 
*   Divide the radial range into an outer and inner part.
      RNOT=0.D0
      RIN=RAV-RNOT
      RUT=RINFIN-RIN

* Make separate logarithmic for inner and outer parts
* The inner part
      RIF=RINFIN
      RNOT=0.D0
      RIN=RAV-RNOT
      TIN=LOG(RIN+1.D0)

* The outer part
      RUT=RINFIN-RAV 
      TUT=LOG(RUT+1.D0)

* The number of cells
      NCELUT=NINT(NCELL*TUT/(TIN+TUT))
      NCELIN=NCELL-NCELUT
      IF(NCELIN.EQ.0) THEN
       NCELIN=1
       NCELUT=NCELL-1
      END IF

* The steps in t-space(s)
      DELTIN=TIN/NCELIN
      DELTUT=TUT/NCELUT

* Beginning of cell and distance between steps 
* in the inner part
      RS(1)=0.D0
      DO 10 I=2,NCELIN
       T=(NCELIN-I+1)*DELTIN
       DR=EXP(T)-1.D0
       RS(I)=RAV-DR
       H(I-1)=(RS(I)-RS(I-1))/(NPOINT-1)
10    CONTINUE
                 
* Beginning of cell and distance between steps
* in the outer part
      RS(NCELIN+1)=RAV
      NC=NCELIN
      DO 20 I=1,NCELUT
       NC=NC+1
       T=(I-1)*DELTUT
       DR=EXP(T)-1.D0
       RS(NC)=RAV+DR
       H(NC-1)=(RS(NC)-RS(NC-1))/(NPOINT-1)
20    CONTINUE
      H(NCELL)=(RINFIN-RS(NCELL))/(NPOINT-1)

      K=0
      DO 200 I=1,NCELL
        CST=RS(I)-H(I)
        DO 200 J=1,NPOINT-1
          K=K+1
          COORD(K)=CST+H(I)*J
200   CONTINUE
      K=K+1
      COORD(K)=COORD(K-1)+H(NCELL)

      RETURN
      END
