      SUBROUTINE DAXPY(NTIMES,ALPHA,XVECTO,INCRX,YVECTO,INCRY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XVECTO(1+(NTIMES-1)*INCRX),YVECTO(1+(NTIMES-1)*INCRY)
 
************************************************************************
*                                                                      *
*     DAXPY : Double precision alpha times X plus Y is equal to Y      *
*                                                                      *
*     Y(I*INCRY+1) = Y(I*INCRY+1) + ALPHA * X(I*INCRX+1)               *
*     For I = 0 to NTIMES-1                                            *
*                                                                      *
*     Written by Dage Sundholm,  10.10.1988                            *
*                                                                      *
************************************************************************
 
*     PARAMETER LIST:
*                     NTIMES = Number of cycles
*                     ALPHA  = Constant
*                     XVECTO = X-vector
*                     INCRX  = Increment of X
*                     YVECTO = Y-vector
*                     INCRY  = Increment of Y
 
      DO 100 I=0,NTIMES-1
        YVECTO(I*INCRY+1)=YVECTO(I*INCRY+1)+ALPHA*XVECTO(I*INCRX+1)
100   CONTINUE
 
      RETURN
      END
