
      SUBROUTINE EIG(A,B,L,N,N1)
C
C Shell to drive Householder algorithm.
C A - MATRIX TO BE DIAGONALIZED (EIGENVALUES IN DIAGS AFTERWARDS)
C B - EIGENVECTORS RETURNED IN COLUMNS
C L - not used
C N - SIZE OF MATRIX
C N1 - EIGENVECTORS AND EIGENVALUES ARE REORDERED, with eigenvalues:
c      1     -- unordered (currently ascending because eispack does it)
c      0     -- ascending
c      other -- descending
C 
CEND
c 91/10/1 DCC use eispack routines instead of numerical recipes
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N,N)
*     integer l, n, n1
*     double precision A(N,N),B(N,N)
*     integer IINTFP, i, j, mu, ierr
*     double precision w1, w2

* In ICOPY one uses IINTFP, FOR DOUBLE PRECISION IINTFP = 2
      IINTFP=2
 
* The quick solution for N=1
      IF(N.EQ.1)THEN
         B(1,1)=1.0
         RETURN
      ENDIF

*  Let's go
      CALL ICOPY(A,B,N*N*IINTFP)
      CALL ZERO(A,N*N)
      CALL TRED2(N,N,B,A(1,1),A(1,2),B)
      CALL TQL2(N,N,A(1,1),A(1,2),B,IERR)
      IF(IERR.NE.0) THEN     
        WRITE (6,*) 'EIG:  Eigenvalue not found -- ', IERR
        CALL EXIT(1)
      END IF
 
      DO 103 I=1,N
         A(I,I)=A(I,1)
 103  CONTINUE
      DO 301 I=1,2
      DO 301 J=I+1,N
         A(J,I)=0.D0
 301  CONTINUE
      A(1,2) = 0.0D0

* Make first significant element of each eigenvector positive
      TOL=1.D-05
      DO 31 I=1,N
        JFIRST=0
        DO 32 J=1,N 
          IF(ABS(B(J,I)).GT.TOL.AND.JFIRST.EQ.0) JFIRST=J 
32      CONTINUE 
        IF(B(JFIRST,I).LT.0.D0) CALL VMINUS(B(1,I),N)
31    CONTINUE 
 
      IF(N1.EQ.1 .OR. N1.EQ.0) RETURN
 
* Sort the eigenvalues and eigenvectors 
      DO 20 I=1, N-1
      DO 20 J=I+1,N
         IF ( A(I,I) .LT. A(J,J) ) THEN
            W1=A(I,I)
            A(I,I)=A(J,J)
            A(J,J)=W1
            DO 10 MU=1,N
               W2=B(MU,I)
               B(MU,I)=B(MU,J)
               B(MU,J)=W2
 10         CONTINUE
         END IF
 20   CONTINUE

      RETURN
      END
