      SUBROUTINE GETMEM (KEY,TYPE,IPOS,LENGTH)
      COMMON/IO/LUIN,LUOUT

      DOUBLE PRECISION WORK, CHWORD
      CHARACTER*(*) KEY, TYPE
      CHARACTER*4 STATUS
      CHARACTER*5 CHECK
      LOGICAL FREE
      PARAMETER (NIPW=2, NRPW=1)
C  NIPW=NR OF INTEGERS PER WORD, SIMILAR NRPW.
C     PARAMETER (MXWRK=4 * 1024 * 1024 - 1 )
      PARAMETER (MXWRK= 1024 * 1024     - 1 )
C  MXWRK=MAX ALLOWED SIZE OF WORK AREA.
      PARAMETER (MXFLD=128)
C  MXFLD=MAX NR OF MAINTAINED FIELDS, FREE+ALLOCATED
      COMMON/BLANK/WORK(0:MXWRK)
      DIMENSION LOC(MXFLD),LEN(MXFLD),FREE(MXFLD)
      SAVE NRFLD,LOC,LEN,FREE
      DATA CHWORD / 11111111111111111.D0 /
*     DATA CHWORD / ZC6D3D6C4C8C1E2E3 /
      DATA NRFLD / 0 /
 
C  THIS SUBROUTINE IS A SIMPLE WORKSPACE MANAGER. ACCEPTED TYPES
C  ARE REAL OR INTEGER. ACCEPTED KEYS ARE ALLOCATE, FREE, CHANGE,
C  MAX, OR LIST.
C  PER-AAKE MALMQUIST, 86-11-28.
 
C  NRFLD=NR OF PRESENTLY MAINTAINED FIELDS. NRFLD=0 INDICATES THE
C  INITIAL CALL.
 
      IF(NRFLD.EQ.0) THEN
        NRFLD=1
        LOC(NRFLD)=0
        LEN(NRFLD)=MXWRK
        FREE(NRFLD)=.TRUE.
      END IF
 
      IF(KEY(1:3).EQ.'LIS') GOTO 901
 
      NUN=0
      IF (TYPE(1:2).EQ.'RE') NUN=NRPW
      IF (TYPE(1:2).EQ.'IN') NUN=NIPW
      IF(NUN.EQ.0) THEN
        WRITE(LUOUT,*)' NO SUCH TYPE.'
        GOTO 900
      END IF
 
      IF(KEY(1:3).EQ.'ALL') THEN
C  ALLOCATE A NEW FIELD AT FIRST FIT.
        IF(LENGTH.LE.0) THEN
          WRITE(LUOUT,*)' PARAMETER OUT OF BOUNDS.'
          GOTO 900
        END IF
        LREQ=NRPW+(LENGTH+NUN-1)/NUN
        DO 10 IFLD=1,NRFLD
          IF(.NOT.FREE(IFLD)) GOTO 10
          IF(LREQ.LE.LEN(IFLD)) GOTO 20
 10     CONTINUE
        WRITE(LUOUT,*)' ALLOCATION FAILED.'
        GOTO 900
 20     LEXC=LEN(IFLD)-LREQ
        LEN(IFLD)=LREQ
        FREE(IFLD)=.FALSE.
        IPOS=NUN*(NRPW+LOC(IFLD))
        WORK(LOC(IFLD))=CHWORD
        IF(LEXC.EQ.0) RETURN
C  REMAINING UNALLOCATED PIECE MUST BE SPLIT OFF.
        GOTO 50
      END IF
 
      IF(KEY(1:3).EQ.'MAX') THEN
C  RETURN SIZE OF LARGEST ALLOCATABLE FIELD, IN UNITS ACCORDING TO
C  TYPE, IN PARAMETER LENGTH.
        JFLD=0
        MXLEN=0
        DO 25 IFLD=1,NRFLD
          IF(.NOT.FREE(IFLD)) GOTO 25
          IF(MXLEN.GE.LEN(IFLD)) GOTO 25
          MXLEN=LEN(IFLD)
          JFLD=IFLD
 25     CONTINUE
        LENGTH=(MXLEN-NRPW)*NUN
        RETURN
      END IF
 
C  IDENTIFY AND CHECK THE REFERENCED FIELD.
      LC=(IPOS/NUN)-NRPW
      DO 30 IFLD=NRFLD,1,-1
        IF(FREE(IFLD)) GOTO 30
        IF(LC.EQ.LOC(IFLD)) GOTO 40
 30   CONTINUE
      WRITE(LUOUT,*)' IDENTIFICATION FAILED.'
      GOTO 900
 
 40   IF(WORK(LC).NE.CHWORD)THEN
        WRITE(LUOUT,*)' WORKSPACE CORRUPTED|'
        GOTO 900
      END IF
 
      IF(KEY(1:3).EQ.'FRE') THEN
C  RELEASE AN ALLOCATED FIELD.
        FREE(IFLD)=.TRUE.
        GOTO 60
C  MERGE ADJACENT FREE FIELD.
      END IF
 
      IF(KEY(1:3).EQ.'CHA') THEN
C  CHANGE SIZE OF PREVIOUSLY ALLOCATED FIELD.
        IF(LENGTH.LE.0) THEN
          WRITE(LUOUT,*)' PARAMETER OUT OF BOUNDS.'
          GOTO 900
        END IF
        LREQ=NRPW+(LENGTH+NUN-1)/NUN
        IF(LREQ.EQ.LEN(IFLD)) RETURN
        IF(LREQ.LT.LEN(IFLD)) THEN
          LEXC=LEN(IFLD)-LREQ
          LEN(IFLD)=LREQ
          GOTO 50
        END IF
        NEED=LREQ-LEN(IFLD)
        IF((IFLD.EQ.NRFLD).OR.(.NOT.FREE(IFLD+1)).OR.
     &     (NEED.GT.LEN(IFLD+1))) THEN
          WRITE(LUOUT,*)' CHANGE REQUEST NOT POSSIBLE.'
          GOTO 900
        END IF
        LEN(IFLD)=LREQ
        LOC(IFLD+1)=LOC(IFLD+1)+NEED
        LEN(IFLD+1)=LEN(IFLD+1)-NEED
        RETURN
      END IF
 
      WRITE(LUOUT,*)' UNRECOGNIZED KEYWORD.'
      GOTO 900
 
 50   CONTINUE
 
C  PERFORM A SPLIT AND RETURN: A SPILL OF FREE SPACE, SIZE LEXC, IS TO
C  BE INSERTED AFTER FIELD NR IFLD.
      IF(IFLD.EQ.NRFLD) THEN
        IF(NRFLD.EQ.MXFLD) THEN
          WRITE(LUOUT,*)' WORKSPACE MANAGEMENT TABLE EXCEEDED.'
          GOTO 900
        END IF
        NRFLD=NRFLD+1
        LOC(NRFLD)=LOC(IFLD)+LEN(IFLD)
        LEN(NRFLD)=LEXC
        FREE(NRFLD)=.TRUE.
        RETURN
      END IF
      IF(FREE(IFLD+1)) THEN
        LOC(IFLD+1)=LOC(IFLD+1)-LEXC
        LEN(IFLD+1)=LEN(IFLD+1)+LEXC
        RETURN
      END IF
      DO 55 JFLD=NRFLD,IFLD+1,-1
        LOC(JFLD+1)=LOC(JFLD)
        LEN(JFLD+1)=LEN(JFLD)
        FREE(JFLD+1)=FREE(JFLD)
 55   CONTINUE
      NRFLD=NRFLD+1
      LOC(IFLD+1)=LOC(IFLD+1)-LEXC
      LEN(IFLD+1)=LEXC
      FREE(IFLD+1)=.TRUE.
      RETURN
 
 60   CONTINUE
C  MERGE ADJACENT FREE FIELDS:
      JFLD=0
      LASTF=0
      DO 65 IFLD=1,NRFLD
        IF(FREE(IFLD)) THEN
          IF(LASTF.EQ.0) THEN
            JFLD=JFLD+1
            LOC(JFLD)=LOC(IFLD)
            LEN(JFLD)=LEN(IFLD)
            FREE(JFLD)=.TRUE.
            LASTF=1
          ELSE
            LEN(JFLD)=LEN(JFLD)+LEN(IFLD)
          END IF
        ELSE
          LASTF=0
          JFLD=JFLD+1
          LOC(JFLD)=LOC(IFLD)
          LEN(JFLD)=LEN(IFLD)
          FREE(JFLD)=.FALSE.
        END IF
 65   CONTINUE
      NRFLD=JFLD
      RETURN
 
 900  CONTINUE
      WRITE(LUOUT,*)' FATAL ERROR IN GETMEM.'
 901  WRITE(LUOUT,*)' WORKSPACE ALLOCATION:'
      WRITE(LUOUT,*)' FIELD CHECK START LOC  LENGTH STATUS'
      DO 902 IFLD=1,NRFLD
        LC=LOC(IFLD)+NRPW
        LN=LEN(IFLD)-NRPW
        IF(FREE(IFLD)) THEN
          STATUS='FREE'
          CHECK=' --- '
        ELSE
          STATUS='ALLO'
          CHECK='ERROR'
          IF(WORK(LOC(IFLD)).EQ.CHWORD) CHECK=' OK| '
        END IF
        WRITE(LUOUT,1001) IFLD,CHECK,LC,LN,STATUS
 902  CONTINUE
      WRITE(LUOUT,*)
      IF(KEY(1:3).EQ.'LIS') RETURN
      WRITE(LUOUT,*)' PARAMETERS OF LAST CALL:'
      WRITE(LUOUT,1002) TYPE(1:2),KEY(1:4),IPOS,LENGTH
      WRITE(LUOUT,*)
      STOP
 1001 FORMAT(1X,I4,2X,A5,3X,I7,1X,I7,2X,A4)
 1002 FORMAT(1X,'TYPE=',A2,', KEY=',A3,', IPOS=',I7,', LENGTH=',I7)
      END
