      SUBROUTINE INTEG(P,N,S,ENDA)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
C   INTEGRATE POLYNOMIALS FROM -ENDA TO ENDA
C   P(1) IS THE CONSTANT VALUE P(2) IS THE LINEAR TERM AND SO ON.
 
C   P(I) = INPUT VECTOR
C   N    = LENGTH OF INPUT VECTOR
C   W    = OUTPUT INTEGRAL VALUE
C   ENDA = INTEGRATION LIMITS
 
      DIMENSION P(N)
 
      LEN=(N-1)/2
      LEN=LEN*2+1
      S=0.
      DO 10 I=LEN,1,-2
      S=ENDA*ENDA*(S+P(I)/I)
10    CONTINUE
      S=2.*S/ENDA
 
      RETURN
      END
