      SUBROUTINE LAGPOL(IPOINT,NPOINT,POLY,IVAR)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
 
C   LEGENDRE POLYNOMIALS OF ORDER NPOINT-1
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION POLY(NPOINT)
 
C   RESET POLY(I)
 
      DO 200 I=1,NPOINT
200   POLY(I)=0.D0
 
      POLY(1)=1.D0
      DO 100 I=1,NPOINT
      IF(I.NE.IPOINT) THEN
       A=-FLOAT(I-IVAR-1)
        IF(I.LT.NPOINT) POLY(I+1)=POLY(I)
        IF(I.NE.1) THEN
          DO 10 J=2,I
          POLY(I-J+2)=A*POLY(I-J+2)+POLY(I-J+1)
10        CONTINUE
          END IF
        POLY(1)=POLY(1)*A
      END IF
100   CONTINUE
 
      DOMI=POLY(1)
      DO 250 I=2,NPOINT
250   DOMI=DOMI+POLY(I)*(1.D0*(IPOINT-IVAR-1))**(I-1)
 
      DO 260 I=1,NPOINT
260   POLY(I)=POLY(I)/DOMI
 
      RETURN
      END
