      SUBROUTINE MATPOI(NPOINT,NCELL,NDIM,IVAR,P1,P2,P3,P4,ALIPS,
     &                  WOR,A1,A2,A3,A4,RS,H)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P1(100),P2(100),P3(100),P4(100)
      DIMENSION WOR(NPOINT*NPOINT*(NPOINT-1))
      DIMENSION ALIPS(NPOINT*NPOINT)
      DIMENSION A1(NPOINT*NPOINT*NCELL)
      DIMENSION A2(NPOINT*NPOINT*NCELL)
      DIMENSION A3(NPOINT*NPOINT*NCELL)
      DIMENSION A4(NPOINT*NPOINT*NCELL)
      DIMENSION RS(NCELL),H(NCELL)
 
C Lagrange Interpolation polynomials (LIPS)
C Set into ALIPS
 
      IDEBUG=0
      CALL LAGGA(ALIPS,NPOINT,IVAR)
 
C INTERPOLATION POLYNOMIALS IN EACH INTERVAL
C To increase the accuracy in the integration step each
C LIP is expanded in each cell interval
C Set into WOR
 
      CALL VCLR(WOR,1,NPOINT*NPOINT*(NPOINT-1))
      XSTART=-0.5D0-IVAR
      CALL TRANS(ALIPS,P3,WOR,NPOINT,XSTART)
 
C Integrals F(I) * F(J)
C Packed into A1
 
      CALL INTGPP(WOR,NPOINT,P2,P3,P1,A1,NCELL,H,NDIM)
 
C Integrals F(I) * F(J) / R
C Packed into A2
 
      CALL INTGRP(WOR,NPOINT,P2,P3,P1,A2,NCELL,RS,H,NDIM)
 
C Integrals  DF(I) * DF(J)
C Packed into A3
 
      CALL INTGDD(WOR,NPOINT,P2,P3,P1,A3,H,NCELL,NDIM)
 
C Integrals  F(I)/R * F(J)/R
C Packed into A4

      CALL INTGRR(WOR,NPOINT,P2,P3,P1,P4,A4,NCELL,RS,H,NDIM)
 
      RETURN
      END
