      SUBROUTINE MRQMIN(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,
     &                  COVAR,ALPHA,NCA,CHISQ,ALAMDA,IFUNC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
*
* The Levenberg-Marquardt Method for non-linear optimization
* Numerical Recipes pp. 523-528
* Copied by Dage Sundholm 27.6.1995
*
      PARAMETER(MMAX=20)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MA)
      DIMENSION COVAR(NCA,NCA),ALPHA(NCA,NCA),ATRY(MMAX) 
      DIMENSION BETA(MMAX),DA(MMAX) 

      IF(ALAMDA.LT.0.D0) THEN
        KK=MFIT+1
        DO 12 J=1,MA
          IHIT=0
          DO 11 K=1,MFIT
            IF(LISTA(K).EQ.J) IHIT=IHIT+1
11        CONTINUE
          IF(IHIT.EQ.0) THEN
            LISTA(KK)=J
            KK=KK+1
          ELSE IF(IHIT.GT.1) THEN 
            WRITE(6,*) ' Improper permutation in LISTA'
            WRITE(6,*) ' Stopped in MRQMIN'
            STOP
          END IF 
12      CONTINUE
        IF(KK.NE.(MA+1)) THEN 
          WRITE(6,*) ' Improper permutation in LISTA'
          WRITE(6,*) ' Stopped in MRQMIN'
          STOP
        END IF 
        ALAMDA=0.001D0
        CALL MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,
     &              NCA,CHISQ,IFUNC)
        OCHISQ=CHISQ
        DO 13 J=1,MA
          ATRY(J)=A(J)
13      CONTINUE
      END IF 

      DO 15 J=1,MFIT
        DO 14 K=1,MFIT
          COVAR(J,K)=ALPHA(J,K)
14      CONTINUE
        COVAR(J,J)=ALPHA(J,J)*(1.D0+ALAMDA)
        DA(J)=BETA(J)
15    CONTINUE

      CALL GAUSSJ(COVAR,MFIT,NCA,DA,1,1)

      IF(ALAMDA.EQ.0.D0) THEN
        CALL COVSRT(COVAR,NCA,MA,LISTA,MFIT)
        RETURN
      END IF
      DO 16 J=1,MFIT
        ATRY(LISTA(J))=A(LISTA(J))+DA(J)
16    CONTINUE
      CALL MRQCOF(X,Y,SIG,NDATA,ATRY,MA,LISTA,MFIT,
     &            COVAR,DA,NCA,CHISQ,IFUNC)
      IF(CHISQ.LT.OCHISQ) THEN
        ALAMDA=ALAMDA*0.1D0
        OCHISQ=CHISQ
        DO 18 J=1,MFIT
          DO 17 K=1,MFIT
            ALPHA(J,K)=COVAR(J,K)
17        CONTINUE
          BETA(J)=DA(J)
          A(LISTA(J))=ATRY(LISTA(J))
18      CONTINUE
      ELSE
        ALAMDA=ALAMDA*10.D0
        CHISQ=OCHISQ  
      END IF
      RETURN
      END
