      SUBROUTINE POLDIV(PT,PN,PUT,IST,NPAR)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION PN(NPAR),PT(NPAR),PUT(NPAR)
 
C      PT(I)/PN(I) = PUT(I)
C DIVIDE POLYNOMIAL PT(I) BY POLYNOMIAL PN(I) GIVES PUT(I)
C START POSITION OF PT MUST ALWAYS BE LARGER THAN OR EQUAL TO
C THE START POSITION OF PN.
C TERMS OF HIGHER ORDER THAN (NPAR-1) ARE NEGLECTED

C  PT(I)  = INPUT (DESTROYED IN THIS ROUTINE)
C  PN(I)  = INPUT
C  PUT(I) = OUTPUT
C  NPAR   = MAX. LENGTH
C  IST    = START POSITION FOR PN
 
      K=0
      DO 20 I=IST,NPAR
        K=K+1
        PUT(K)=PT(I)/PN(IST)
        L=0
          DO 20 J=I,NPAR
          L=L+1
          PT(J)=PT(J)-PUT(K)*PN(IST+L-1)
20    CONTINUE
 
      RETURN
 
      END
