      SUBROUTINE POTREA(SRAD,SPRO,SPOT1,SPOT2,
     &                       PROP,POT1, POT2,
     &                  HELP1,HELP2,
     &                  COORD,NDIM,LUIN,LUOUT,NSAMPL,ITRANS,
     &                  PSHIF1,PSHIF2)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*72 CARD

      DIMENSION SRAD(NSAMPL),SPRO(NSAMPL),SPOT1(NSAMPL),SPOT2(NSAMPL)
      DIMENSION PROP(NDIM),POT1(NDIM),POT2(NDIM),COORD(NDIM)
      DIMENSION HELP1(NSAMPL),HELP2(NSAMPL)

      WRITE(LUOUT,*)
      WRITE(LUOUT,*) '*******************************************'
      WRITE(LUOUT,*) '*  Input data for potentials and property *'
      WRITE(LUOUT,*) '*******************************************'
      WRITE(LUOUT,*)

* Read the data title card 
      READ(LUIN,'(A)') CARD 

*  An rovibrational averaging (SPOT2 is not used)
      IF(ITRANS.EQ.0) THEN
        WRITE(LUOUT,*)
     &  'No Radial Points   Property Points  Potential Points '
        WRITE(LUOUT,*) 
        DO 100 I=1,NSAMPL
          ISAV=I
          READ(LUIN,*,END=105) SRAD(I),SPRO(I),SPOT1(I)
          WRITE(LUOUT,'(I2,1X,3(D15.9,2X))') 
     &    I,SRAD(I),SPRO(I),SPOT1(I)
100     CONTINUE
105     CONTINUE  
        IF(ISAV.LT.NSAMPL) THEN
          WRITE(LUOUT,*)
          WRITE(LUOUT,'(A)') ' The number of read data points is less'
          WRITE(LUOUT,'(A)') ' than the number of data points given in'
          WRITE(LUOUT,'(A)') ' your input'
          WRITE(LUOUT,'(A)') ' Check your input deck'
          WRITE(LUOUT,'(A)') ' I stop in POTREA'
          WRITE(LUOUT,*)
          STOP
        END IF
*
* spline interpolation for the first potential
        YP1=(SPOT1(2)-SPOT1(1))/(SRAD(2)-SRAD(1))
        YPN=(SPOT1(NSAMPL)-SPOT1(NSAMPL-1))
     &     /(SRAD(NSAMPL)-SRAD(NSAMPL-1))
        CALL SPLINE(SRAD,SPOT1,NSAMPL,YP1,YPN,HELP1,HELP2)
* Find the initial guess for R0 and D0
        CALL FIRDER(SRAD,SPOT1,HELP2,NSAMPL,HELP1) 
        CALL FINMIN(SRAD,SPOT1,HELP1,HELP2,NSAMPL,R0,D0)
        PSHIF1=-D0+1.D0
        ICALL=1
        IVAL=1
        DO 106 I=1,NDIM
* If the coordinates are within the sample interval, interpolate
         IF(COORD(I).GE.SRAD(1).AND.COORD(I).LE.SRAD(NSAMPL)) THEN
           CALL SPLINT(SRAD,SPOT1,HELP2,NSAMPL,COORD(I),POT1(I),LUOUT)
         ELSE
* Outside the interval the function are obtained from extrapoltion
* of using a well behaved function
           CALL EXPOLA(SRAD,SPOT1,HELP1,NSAMPL,R0,D0,COORD(I),
     &                 SRAD(1),SRAD(NSAMPL),SPOT1(1),SPOT1(NSAMPL),
     &                 IVAL,ICALL,POT1(I),LUOUT)
           ICALL=ICALL+1
         END IF
106     CONTINUE
*
* spline interpolation for the property function
        YP1=(SPRO(2)-SPRO(1))/(SRAD(2)-SRAD(1))
        YPN=(SPRO(NSAMPL)-SPRO(NSAMPL-1))/(SRAD(NSAMPL)-SRAD(NSAMPL-1))
        CALL SPLINE(SRAD,SPRO,NSAMPL,YP1,YPN,HELP1,HELP2)
        IVAL=3
        ICALL=1
        DO 107 I=1,NDIM
* If the coordinates are within the sample interval, interpolate
          IF(COORD(I).GE.SRAD(1).AND.COORD(I).LE.SRAD(NSAMPL)) THEN
            CALL SPLINT(SRAD,SPRO,HELP2,NSAMPL,COORD(I),PROP(I),LUOUT)
          ELSE 
* Outside the interval the function are obtained from extrapoltion
* of using a well behaved function
*          CALL EXPOLA(SRAD,SPRO,HELP1,NSAMPL,R0,D0,COORD(I),
*    &                 SRAD(1),SRAD(NSAMPL),SPRO(1),SPRO(NSAMPL),
*    &                 IVAL,ICALL,PROP(I),LUOUT)
           if(icall.eq.1) then
           WRITE(6,*) 'The extrapolation of the property function is'
           WRITE(6,*) 'simply repetion of the value of the last point'
           end if
           IF(COORD(I).LE.SRAD(1)) PROP(I)=SPRO(1)
           IF(COORD(I).GT.SRAD(NSAMPL)) PROP(I)=SPRO(NSAMPL)
           ICALL=ICALL+1
          END IF
107     CONTINUE
      END IF

*  An transition property 
      IF(ITRANS.EQ.1) THEN
        WRITE(LUOUT,*) 
     &  'No Radial Points   Property Points  Potential Points  Potential
     & Points'
        WRITE(LUOUT,*) 
        DO 200 I=1,NSAMPL
          ISAV=I
          READ(LUIN,*,END=205) SRAD(I),SPRO(I),SPOT1(I),SPOT2(I) 
          WRITE(LUOUT,'(I2,1X,4(D15.9,2X))') 
     &    I,SRAD(I),SPRO(I),SPOT1(I),SPOT2(I)
200     CONTINUE  
205     CONTINUE  
        IF(ISAV.LT.NSAMPL) THEN
          WRITE(LUOUT,*)
          WRITE(LUOUT,'(A)') ' The number of read data points is less'
          WRITE(LUOUT,'(A)') ' than the number of data points given in'
          WRITE(LUOUT,'(A)') ' your input'
          WRITE(LUOUT,'(A)') ' Check your input deck'
          WRITE(LUOUT,'(A)') ' I stop in POTREA'
          WRITE(LUOUT,*)
          STOP
        END IF
*
* spline interpolation for the first potential
        YP1=(SPOT1(2)-SPOT1(1))/(SRAD(2)-SRAD(1))
        YPN=(SPOT1(NSAMPL)-SPOT1(NSAMPL-1))
     &     /(SRAD(NSAMPL)-SRAD(NSAMPL-1))
        CALL SPLINE(SRAD,SPOT1,NSAMPL,YP1,YPN,HELP1,HELP2)
* Find the initial guess for R0 and D0
        CALL FIRDER(SRAD,SPOT1,HELP2,NSAMPL,HELP1) 
        CALL FINMIN(SRAD,SPOT1,HELP1,HELP2,NSAMPL,R0,D0)
        PSHIF1=-D0+1.D0
        IVAL=1
        ICALL=1
        DO 206 I=1,NDIM
* If the coordinates are within the sample interval, interpolate
         IF(COORD(I).GE.SRAD(1).AND.COORD(I).LE.SRAD(NSAMPL)) THEN
           CALL SPLINT(SRAD,SPOT1,HELP2,NSAMPL,COORD(I),POT1(I),LUOUT)
         ELSE
* Outside the interval the function are obtained from extrapoltion
* of using a well behaved function
           CALL EXPOLA(SRAD,SPOT1,HELP1,NSAMPL,R0,D0,COORD(I),
     &                 SRAD(1),SRAD(NSAMPL),SPOT1(1),SPOT1(NSAMPL),
     &                 IVAL,ICALL,POT1(I),LUOUT)
           ICALL=ICALL+1
         END IF
206     CONTINUE
*
* spline interpolation for the property function
        YP1=(SPRO(2)-SPRO(1))/(SRAD(2)-SRAD(1))
        YPN=(SPRO(NSAMPL)-SPRO(NSAMPL-1))/(SRAD(NSAMPL)-SRAD(NSAMPL-1))
        CALL SPLINE(SRAD,SPRO,NSAMPL,YP1,YPN,HELP1,HELP2)
        ICALL=1
        IVAL=3
        DO 207 I=1,NDIM
* If the coordinates are within the sample interval, interpolate
          IF(COORD(I).GE.SRAD(1).AND.COORD(I).LE.SRAD(NSAMPL)) THEN
            CALL SPLINT(SRAD,SPRO,HELP2,NSAMPL,COORD(I),PROP(I),LUOUT)
          ELSE
* Outside the interval the function are obtained from extrapoltion
* of using a well behaved function
*          CALL EXPOLA(SRAD,SPRO,HELP1,NSAMPL,R0,D0,COORD(I),
*    &                 SRAD(1),SRAD(NSAMPL),SPRO(1),SPRO(NSAMPL),
*    &                 IVAL,ICALL,PROP(I),LUOUT)
           if(icall.eq.1) then
           WRITE(6,*) 'The extrapolation of the property function is'
           WRITE(6,*) 'simply repetion of the value of the last point'
           end if
           IF(COORD(I).LE.SRAD(1)) PROP(I)=SPRO(1)
           IF(COORD(I).GT.SRAD(NSAMPL)) PROP(I)=SPRO(NSAMPL)
           ICALL=ICALL+1  
          END IF
207     CONTINUE
*
* spline interpolation for the second potential
        YP1=(SPOT2(2)-SPOT2(1))/(SRAD(2)-SRAD(1))
        YPN=(SPOT2(NSAMPL)-SPOT2(NSAMPL-1))
     &     /(SRAD(NSAMPL)-SRAD(NSAMPL-1))
        CALL SPLINE(SRAD,SPOT2,NSAMPL,YP1,YPN,HELP1,HELP2)
* Find the initial guess for R0 and D0
        CALL FIRDER(SRAD,SPOT2,HELP2,NSAMPL,HELP1) 
        CALL FINMIN(SRAD,SPOT2,HELP1,HELP2,NSAMPL,R0,D0)
        PSHIF2=-D0+1.D0
        IVAL=2
        ICALL=1
        DO 208 I=1,NDIM
* If the coordinates are within the sample interval, interpolate
         IF(COORD(I).GE.SRAD(1).AND.COORD(I).LE.SRAD(NSAMPL)) THEN
           CALL SPLINT(SRAD,SPOT2,HELP2,NSAMPL,COORD(I),POT2(I),LUOUT)
         ELSE
* Outside the interval the function are obtained from extrapoltion
* of using a well behaved function
           CALL EXPOLA(SRAD,SPOT2,HELP1,NSAMPL,R0,D0,COORD(I),
     &                 SRAD(1),SRAD(NSAMPL),SPOT2(1),SPOT2(NSAMPL),
     &                 IVAL,ICALL,POT2(I),LUOUT)
           ICALL=ICALL+1
         END IF
208     CONTINUE
      END IF

      WRITE(LUOUT,*)
      WRITE(LUOUT,*)' The interpolated property and potential functions'
      WRITE(LUOUT,*) 
      IF(ITRANS.EQ.0) THEN
        WRITE(LUOUT,*)
     &  'Radial Point       Property Points  Potential Points' 
        WRITE(LUOUT,*)
        DO 1200 I=1,NDIM
          WRITE(LUOUT,'(I3,1X,3(D15.9,2X))')
     &    I,COORD(I),PROP(I),POT1(I)
1200    CONTINUE
      END IF

      IF(ITRANS.EQ.1) THEN
        WRITE(LUOUT,*)
     &  'Radial Point       Property Points  Potential Points  Potential
     & Points'
        WRITE(LUOUT,*)
        DO 2200 I=1,NDIM
          WRITE(LUOUT,'(I3,1X,4(D15.9,2X))')
     &    I,COORD(I),PROP(I),POT1(I),POT2(I)
2200    CONTINUE
      END IF
*
* Then we have to shift the potentials so that they are 
* always larger than zero and then we take the square root 
* The program assumes that we have the square root of the potentials.
* Shift so that the first point is not at r=0. 
* which is assumed later in the program
*    
      IF(ITRANS.EQ.0) THEN 
        DO 10001 I=2,NDIM-1
          POT1(I)=POT1(I)+PSHIF1
          POT1(I-1)=SQRT(POT1(I))
10001   CONTINUE
        POT1(NDIM-1)=0.D0
        POT1(NDIM)=0.D0
        DO 10003 I=2,NDIM-1
          PROP(I-1)=PROP(I)
10003   CONTINUE
        PROP(NDIM-1)=0.D0
        PROP(NDIM)=0.D0
      END IF

      IF(ITRANS.EQ.1) THEN 
        DO 20001 I=2,NDIM-1
          POT1(I)=POT1(I)+PSHIF1
          POT1(I-1)=SQRT(POT1(I))
20001   CONTINUE 
        POT1(NDIM-1)=0.D0
        POT1(NDIM)=0.D0
        DO 20002 I=2,NDIM-1
          POT2(I)=POT2(I)+PSHIF2
          POT2(I-1)=SQRT(POT2(I))
20002   CONTINUE
        POT2(NDIM-1)=0.D0
        POT2(NDIM)=0.D0
        DO 20003 I=2,NDIM-1
          PROP(I-1)=PROP(I)
20003   CONTINUE
        PROP(NDIM-1)=0.D0
        PROP(NDIM)=0.D0
      END IF

      RETURN
      END 
