      SUBROUTINE PROMUL(EIGE,PROPER,NDIM,S,SCR,PROVEC)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION EIGE(NDIM-2,NDIM-2),S(NDIM-2,NDIM-2),PROPER(NDIM-2)
      DIMENSION SCR(NDIM-2,NDIM-2),PROVEC(NDIM-2,NDIM-2)

* The desired integrals are < psi | property | psi >
* Multiply the eigenfunctions by the property vector
      DO 100 I=1,NDIM-2
        DO 100 J=1,NDIM-2
          SCR(J,I)=EIGE(J,I)*PROPER(J)
100   CONTINUE

*  Multiply eigenfunction times property vector by the overlap matrix
      CALL MATML4(PROVEC,S,SCR,
     &            NDIM-2,NDIM-2,NDIM-2,NDIM-2,NDIM-2,NDIM-2,0)

      RETURN
      END
