      SUBROUTINE SPLINT(XA,YA,Y2A,NMAX,X,Y,LUOUT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XA(NMAX),YA(NMAX),Y2A(NMAX)
*
*  INPUT:  XA(I)  : The X-values
*          YA(I)  : The Y-values
*          Y2A(I) : The second derivative at each X(I)
*          NMAX   : Number of X,Y pairs
*          X      : The desired X-value
*
*  OUTPUT: Y      : Y-value for the desired X-value
*
*
*  Numerical Recipes page 89
*  Copied by Dage Sundholm, 16.6.1995, debugged 22.6.1995 ok.
*
      KLO = 1
      KHI = NMAX
1       IF(KHI-KLO.GT.1) THEN
          K=(KHI+KLO)/2
          IF(XA(K).GT.X) THEN
            KHI=K
          ELSE
            KLO=K
          END IF
        GO TO 1
      END IF
      H=XA(KHI)-XA(KLO)
      IF(H.EQ.0.D0) THEN
        WRITE(LUOUT,*) ' Bad XA input in SPLINT'
        WRITE(LUOUT,*) ' Check the input data '
        WRITE(LUOUT,*) ' I stop in SPLINT'
        STOP
      END IF

      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      Y=A*YA(KLO)+B*YA(KHI)+
     &  ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.D0

      RETURN
      END
