      SUBROUTINE TEMPAV(ENERGY,SIGMA,minvdi,maxvdi,minjdi,maxjdi,
     &                  TEMPER,NTEMP,IODD)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      implicit double precision (a-h,o-z)
      double precision k
      integer vmin,vmax,v
      dimension sigma(minvdi:maxvdi,minjdi:maxjdi)
      dimension energy(minvdi:maxvdi,minjdi:maxjdi) 
      DIMENSION TEMPER(1000) 
      DIMENSION TMP(1000)

      vmin=minvdi
      vmax=maxvdi
      jmin=minjdi
      jmax=maxjdi

* some constants
      h=6.62607550D-34
      c=2.99792458D+08
      k=1.38065800D-23

* energy from cm-1 to J
      do v=vmin,vmax
        do j=jmin,jmax
          energy(v,j)=energy(v,j)*100.d0*h*c
        end do
      end do

      if(IODD.EQ.0.AND.jmin.gt.0) then
        write(6,*) ' JMIN have to be equal to zero '
        write(6,*) ' stopped in tempav '
        stop 
      end if 
      if(IODD.EQ.2.AND.jmin.gt.0) then
        write(6,*) ' JMIN have to be equal to zero '
        write(6,*) ' stopped in tempav '
        stop
      end if
      if(vmin.gt.1) then
        write(6,*) ' the first vibrational level should probably be 0'
        write(6,*) ' check the input deck'
        stop
      end if 

      IF(IODD.EQ.0) then 
        refene=energy(vmin,jmin)
        jstep=1
        jstart=0
        jstop=jmax
      END IF
      IF(IODD.EQ.1) then
        refene=energy(vmin,1)
        jstep=2
        jstart=1
        jstop=jmax
      END IF
      IF(IODD.EQ.2) then
        refene=energy(vmin,jmin)
        jstep=2
        jstart=0
        jstop=jmax
      END IF

      WRITE(6,*) ' Averaged value for property at temperture (in K)'
      WRITE(6,*) ' Temperature (in K)       Property value'
      WRITE(6,*) 

      DO ITEMP=1,NTEMP
        T=TEMPER(ITEMP) 
        IF(T.LT.1.D-04) T=1.D-04
        
* Average
        prop=0.d0
        sum=0.d0
        do v=vmin,vmax
          do j=jstart,jstop,jstep
            occ=(2*j+1)*exp((refene-energy(v,j))/k/T)
            sum=sum+occ
            del=sigma(v,j)*occ
            prop=prop+del 
            if(v.eq.vmin) della=del
            if(v.eq.vmax.and.j.eq.jstart) dekka=del
          end do
        end do

        write(6,'(A,3X,D13.6,3X,D13.6)') 'TEMP',T,prop/sum
        TMP(ITEMP)=max(dekka/sum,della/sum)

      end do  
       write(6,*) 
       write(6,*) 

      WRITE(6,*) 'Contribution from last rotational state (v=vmin) or'  
      WRITE(6,*) 'Contribution from the last vibrational state (J=Jmin)'
      WRITE(6,*) ' Temperature (in K)       Property value'
      WRITE(6,*)
      DO I=1,NTEMP
       write(6,'(A,3X,D13.6,3X,D13.6)') 'DELT',TEMPER(I),TMP(I)
      end do 
       write(6,*) 
       write(6,*) 
       write(6,*) 

      return
      end 
