      SUBROUTINE TESTMA(A,S,W,V,NCELL,NPOINT,NDIM,C,T,RS,H)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NDIM-2,NDIM-2),S(NDIM-2,NDIM-2),V(NDIM-2,NDIM-2)
      DIMENSION C(NDIM-2,NDIM-2),T(NDIM-2,NDIM-2)
      DIMENSION RS(NCELL),H(NCELL)
      COMMON/IO/LUIN,LUOUT

* This is a complete test subroutine
* By the following modifications the problem can be changed into 
* a H-like atom the energy of which is analytically known.
* 1) Call TESTMA after SETMAT set desired ZETA here 
* 2) Set desired zeta in TOTHAM  

      ZETA=1.D0

      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A)') ' The reduced mass is set to 1' 
      WRITE(LUOUT,'(A)') ' in TESTMA' 
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A)') ' A 1s function is initialized with zeta'
      WRITE(LUOUT,'(D16.10)') ZETA
      WRITE(LUOUT,*)

* 1) Setup a test function (1s)
      K=0
      DO 10 ICELL=1,NCELL
        IEND=NPOINT-1
        IF(ICELL.EQ.1) THEN
          IST=2
          R=RS(ICELL)
        ELSE
          IST=1
          R=RS(ICELL)-H(ICELL)
        END IF
        DO 10 IP=IST,IEND
          K=K+1
          R=R+H(ICELL)
          T(K,1)=R*EXP(-ZETA*R)
10    CONTINUE

* 2)  Normalization and set to T(1,1)
      CALL MATTVE(S,T(1,1),T(1,2),NDIM-2)
      ANO=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' The normalization constant N**2 ',ANO
      WRITE(LUOUT,*)
      ANO=1.D0/SQRT(ANO)
      CALL VCLR(T(1,2),1,NDIM)
      CALL DAXPY(NDIM-2,ANO,T(1,1),1,T(1,2),1)
      CALL VMOV(T(1,2),1,T(1,1),1,NDIM-2)
  
* 3)  Kinetic energy 
      CALL VCLR(T(1,2),1,NDIM)
      CALL MATTVE(A,T(1,1),T(1,2),NDIM-2)
      EKIN=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' The kinetic energy ',EKIN
      WRITE(LUOUT,*)
 
* 4)  Potential energy
      CALL VCLR(T(1,2),1,NDIM)
      CALL MATTVE(W,T(1,1),T(1,2),NDIM-2)
      EPOT=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      EPOT=EPOT*ZETA
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' The potential (1/r) energy ',EPOT
      WRITE(LUOUT,*)

      ETOT=EKIN+EPOT
      VIRI=EPOT/EKIN

      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' The total energy of the 1s orbital is ',ETOT
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' Virial theorem for the 1s  orbital is ',VIRI
      WRITE(LUOUT,*)

* 5) Setup a test function (2p)
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A)') ' A 2p function is initialized with zeta'
      WRITE(LUOUT,'(D16.10)') ZETA
      WRITE(LUOUT,*)

      K=0
      DO 110 ICELL=1,NCELL
        IEND=NPOINT-1
        IF(ICELL.EQ.1) THEN
          IST=2
          R=RS(ICELL)
        ELSE
          IST=1
          R=RS(ICELL)-H(ICELL)
        END IF
        DO 110 IP=IST,IEND
          K=K+1
          R=R+H(ICELL)
          T(K,1)=R*R*EXP(-R*ZETA/2.D0)
110   CONTINUE

* 6)  Normalization and set to T(1,1)
      CALL MATTVE(S,T(1,1),T(1,2),NDIM-2)
      ANO=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)')
     & ' The normalization constant N**2 ',ANO
      WRITE(LUOUT,*)
      ANO=1.D0/SQRT(ANO)
      CALL VCLR(T(1,2),1,NDIM)
      CALL DAXPY(NDIM-2,ANO,T(1,1),1,T(1,2),1)
      CALL VMOV(T(1,2),1,T(1,1),1,NDIM-2)
 
* 7)  Kinetic energy
      CALL VCLR(T(1,2),1,NDIM)
      CALL MATTVE(A,T(1,1),T(1,2),NDIM-2)
      EKIN=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)') 
     & ' The kinetic energy ',EKIN
      WRITE(LUOUT,*)

* 8)  Potential energy
      CALL VCLR(T(1,2),1,NDIM)
      CALL MATTVE(W,T(1,1),T(1,2),NDIM-2)
      EPOT=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      EPOT=EPOT*ZETA
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)') 
     & ' The potential (1/r) energy ',EPOT
      WRITE(LUOUT,*)

* 9)  Centrifugal potential 
      CALL VCLR(T(1,2),1,NDIM)
      CALL MATTVE(V,T(1,1),T(1,2),NDIM-2)
      ECEN=DDOT(NDIM-2,T(1,1),1,T(1,2),1)
      J=1
      ECEN=J*(J+1)*ECEN
      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)') 
     & ' The centrifugal potential energy for J = 1 ',ECEN
      WRITE(LUOUT,*)
      
      ETOT=EKIN+EPOT+ECEN
      VIRI=EPOT/(EKIN+ECEN)

      WRITE(LUOUT,*)
      WRITE(LUOUT,'(A,1X,D16.10)') 
     & ' The total energy of the 2p orbital is ',ETOT
      WRITE(LUOUT,'(A,1X,D16.10)') 
     & ' Virial theorem for the 2p  orbital is ',VIRI 
      WRITE(LUOUT,*)

      RETURN
      END 
