      SUBROUTINE TPOLMU(VIN1,LEN1,VIN2,LEN2,VUT,LENMAX)
********************************************************************************
*                                                                              *
*  Copyright (C) Dage Sundholm, sundholm@chem.helsinki.fi                      *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program; if not, write to the Free Software                 *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                              *
********************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VIN1(LEN1),VIN2(LEN2),VUT(LENMAX)
 
C MULTIPLY VIN1(I) * VIN2(J) = VUT(K) AND TRUNCATE TO ORDER (LENMAX-1)
C VIN1(I) = INPUT VECTOR OF LENGTH LEN1
C VIN2(J) = INPUT VECTOR OF LENGTH LEN2
C VUT(K)  = OUTPUT VECTOR OF LENGTH LENMAX
C VECTOR ELEMENTS ARE ORDERED SUCH THAT THE CONSTANT ELEMENT COMES FIRST
C AND THE LINEAR TERM IS THE NEXT ONE AND SO ON.
 
      CALL VCLR(VUT,1,LENMAX)
      DO 100 I=1,LEN1
        DO 100 J=1,LEN2
        K=I+J-1
        IF(K.LE.LENMAX) THEN
        VUT(K)=VUT(K)+VIN1(I)*VIN2(J)
        END IF
100   CONTINUE
 
      RETURN
      END
